clear all

program define Descfile
    syntax using/, book(string)
    
    qui use "`using'", clear
    
    if `"`: data label'"' != "" {
        file write `book' `"<h2>`:data label'</h2>"' _n
    }
    if "`: char _dta[note0]'" != "" {
        file write `book' "<h3>Notes:</h3>"_n"<ul>"_n
        forvalues i = 1/`: char _dta[note0]' {
            file write `book' `"<li>`: char _dta[note`i']'</li>"' _n
        }
        file write `book' "</ul>"_n
    }
end

program define Descvars
    syntax, book(string)
    
    file write `book' "<h3>Variable list</h3>"
    file write `book' "<ul>"_n
    foreach var of varlist * {
        file write `book' "<li>`var'"
        if `"`: var label `var''"' != "`var'" {
            file write `book' `": `: var label `var''"'
        }
        file write `book' "</li>"_n
        if "`: char `var'[note0]'" != "" {
            file write `book' "<ul>" _n
            forvalues i = 1/`: char `var'[note0]'{
                file write `book' `"<li>`: char `var'[note`i']'</li>"'
            }
            file write `book' "</ul>" _n
        }
    }
    file write `book' "</ul>"
end    

program define Descvalues                                     //new
    syntax, book(string) file(string)                         //new
                                                              //new
    foreach var of varlist * {                                //new
        local vallab : val label `var'                        //new
        if "`vallab'" != "" {                                 //new
            file write `book' `"<h4>`var'"'                   //new
            local varlab : var label `var'                    //new
            if `"`varlab'"' != "`var'" {                      //new
                file write `book' `": `varlab'"'              //new
            }                                                 //new 
            file write `book' "</h4>"_n                       //new  
            qui uselabel `vallab'                             //new  
            file write `book' "<table>"_n                     //new
            forvalues i = 1/`=_N' {                           //new
                file write `book' "<tr>"                      //new
                file write `book' `"<td>`=value[`i']'</td>"'  //new
                file write `book' `"<td>`=label[`i']'</td>"'  //new
                file write `book' "</td>"_n                   //new
            }                                                 //new
            file write `book' "</table>"_n                    //new
            qui use `file', clear                             //new
        }                                                     //new
    }                                                         //new
                                                              //new
end                                                           //new

program define htmlcodebook
    version 14
    syntax using/ , SAVing(string) [replace title(string)]
    
    tempname book 
    file open `book' using `saving', write `replace'
    preserve
    
    file write `book' "<!DOCTYPE html>"_n"<html>"_n
    file write `book' "<style>"_n
    file write `book' "body {"_n
    file write `book' "width: 650px;"_n
    file write `book' "margin: auto;"_n
    file write `book' "}"_n
    file write `book' "</style>"_n
    file write `book' "<body>"_n
    
    if `"`title'"' != "" {
        file write `book' "<h1>`title'</h1>"_n
    }
    else {
        file write `book' "<h1>Codebook for `using'</h1>"_n
    }
    
    Descfile using "`using'", book(`book')
    Descvars, book(`book')
    Descvalues, book(`book') file(`using')                      //new  
    
    file write `book' "</body>"_n
    file write `book' "</html>"_n
    file close `book'
    di as txt "Output written to " `"{browse "`saving'"}"'    
    restore
end

cd h:\ss18\stata_l2
htmlcodebook using arc06.dta, saving(test.html) replace

